您的位置:首页 > 大数据 > 人工智能

2017.11.22 LeetCode - 532. K-diff Pairs in an Array【简单二分】

2017-11-22 22:09 567 查看

532. K-diff Pairs in an Array

Description

Given an array of integers and an integer k, you need to find the number of unique k-diff pairs in the array. Here a k-diff pair is defined as an integer pair (i, j), where i and j are both numbers in the array and their absolute difference is k.

Example 1:

Input: [3, 1, 4, 1, 5], k = 2

Output: 2

Explanation: There are two 2-diff pairs in the array, (1, 3) and (3, 5).

Although we have two 1s in the input, we should only return the number of unique pairs.

Example 2:

Input:[1, 2, 3, 4, 5], k = 1

Output: 4

Explanation: There are four 1-diff pairs in the array, (1, 2), (2, 3), (3, 4) and (4, 5).

Example 3:

Input: [1, 3, 1, 5, 4], k = 0

Output: 1

Explanation: There is one 0-diff pair in the array, (1, 1).

Note:

The pairs (i, j) and (j, i) count as the same pair.

The length of the array won’t exceed 10,000.

All the integers in the given input belong to the range: [-1e7, 1e7].

题意: 给你一个数组,让你找出几对数(i,j),保证abs(i-j) == k

分析: 排完序,直接对每个数字二分下即可,(其实暴力也可以过,范围小),用二分的话,得考虑一下当k为0的情况,所以我在这里用了upper_bound,来看下右界,就可以方便的判重了

参考函数

class Solution {
public:
int findPairs(vector<int>& nums, int k) {
int res = 0;
sort(nums.begin(),nums.end());
for(int i = 0;i < nums.size();i++) {
int t = upper_bound(nums.begin(),nums.end(),nums[i]+k)-nums.begin()-1;
if(nums[t] - k == nums[i] && t > i) res++;
while(nums[i] == nums[i+1]) i++;
}
return res;
}
};
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: